<template lang="pug">
div.b-files-list(
  :class=`{
    'b-files-list--has-top-space': $attrs.hasTopSpace
  }`
)
  v-layout(row wrap justify-space-between)
      v-flex(md12)
        btn(
          :clickAction="loadAction"
          :isDisabled="isLoadedFiles"
        )
          | Выгрузить отчеты

  v-layout(row wrap v-if="files && files.length !== 0")
    v-flex(xs12 sm12 md12)
      p.b-content__title-section Список доступных отчетов:

  v-layout(row wrap v-if="files && files.length !== 0")
    v-flex(xs12 sm12 md12)
      .b-files-list__list
        a.b-files-list__item(
          v-for="file in files" 
          :href="fileServer + file.downloadLink"
          download
          @click="download($event, file.isReady, file.message)"
          :class=`{
            'b-files-list__item--not-ready': !file.isReady,
            'b-files-list__item--is-load': getTimeId,
            'b-files-list__item--is-error': file.message === 'внутренняя ошибка'
          }`
        )
          .b-files-list__icon
            v-icon(color="#2a4d7d") attachment
          .b-files-list__info
            .b-files-list__name Отчет: {{file.name}}
            .b-files-list__date {{file.message}}

</template>

<script>
import Btn from '../button/index.vue';
import { mapGetters } from 'vuex';

export default {
  name: 'FilesList',
  components: {
    Btn,
  },
  props: {
    loadAction: {
      type: Function,
      default: () => null,
    },
    files: {
      type: Array,
      default: [],
    },
    fileServer: {
      type: String,
      default: '',
    },
  },
  computed: {
    ...mapGetters(['getTimeId', 'isLoadedFiles']),
  },
  methods: {
    download(e, ready, message) {
      if (!ready || message === 'внутренняя ошибка') {
        e.preventDefault();
        if (message === 'внутренняя ошибка') {
          this.$notify({
            group: 'note',
            type: 'error',
            title: 'Внутренняя ошибка',
            text: '',
          });
        } else {
          this.$notify({
            group: 'note',
            type: 'info',
            title: `Файл: ${message}`,
            text: '',
          });
        }
        
      }
    }
  }
};
</script>

<style lang="scss">
@import '@/assets/styles/additional/_variables.scss';
@import '@/blocks/files-list/files-list.scss'
</style>
